# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%bcond_without repolib

%define section free

%define reltag .redhat_4
%define namedversion %{version}-redhat-4

%define shortname objectweb-asm

Name:           objectweb-asm-eap6
Version:        3.3.1
Release:        6.2%{reltag}%{?dist}
Epoch:          0
Summary:        Code manipulation tool to implement adaptable systems
License:        BSD
URL:            http://asm.objectweb.org/
Group:          Development/Libraries/Java
Source0:        http://download.forge.objectweb.org/asm/asm-%{version}.tar.gz
Source1:        asm-%{version}.pom
Source11:        asm-%{version}-vman.pom
#based on Source1:        http://repo1.maven.org/maven2/asm/asm/3.3.1/asm-3.3.1.pom
Source2:        asm-analysis-%{version}.pom
Source12:        asm-analysis-%{version}-vman.pom
#based on Source2:        http://repo1.maven.org/maven2/asm/asm-analysis/3.3.1/asm-analysis-3.3.1.pom
Source3:        asm-commons-%{version}.pom
Source13:        asm-commons-%{version}-vman.pom
#based on Source3:        http://repo1.maven.org/maven2/asm/asm-commons/3.3.1/asm-commons-3.3.1.pom
Source4:        asm-tree-%{version}.pom
Source14:        asm-tree-%{version}-vman.pom
#based on Source4:        http://repo1.maven.org/maven2/asm/asm-tree/3.3.1/asm-tree-3.3.1.pom
Source5:        asm-util-%{version}.pom
Source15:        asm-util-%{version}-vman.pom
#based on Source5:        http://repo1.maven.org/maven2/asm/asm-util/3.3.1/asm-util-3.3.1.pom
Source6:        asm-xml-%{version}.pom
Source16:        asm-xml-%{version}-vman.pom
#based on Source6:        http://repo1.maven.org/maven2/asm/asm-xml/3.3.1/asm-xml-3.3.1.pom
Source7:        asm-all-%{version}.pom
Source17:        asm-all-%{version}-vman.pom
#based on Source7:        http://repo1.maven.org/maven2/asm/asm-all/3.3.1/asm-all-3.3.1.pom
Source8:        asm-parent-%{version}.pom
Source18:        asm-parent-%{version}-vman.pom
#based on Source8:        http://repo1.maven.org/maven2/asm/asm-parent/3.3.1/asm-parent-3.3.1.pom
Source9:        asm-MANIFEST.MF
Source10:        asm-debug-all-%{version}.pom
Source20:        asm-debug-all-%{version}-vman.pom
#based on Source10:        http://repo1.maven.org/maven2/asm/asm-debug-all/3.3.1/asm-debug-all-3.3.1.pom

Patch0:         objectweb-asm-eap6-version.patch

Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
# Needed by asm-xml.jar
BuildRequires:  ant >= 0:1.7
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  jpackage-utils
BuildRequires:  objectweb-anttask
BuildRequires:  xml-commons-jaxp-1.3-apis
BuildRequires:  apache-commons-parent
BuildRequires:  jboss-parent
BuildRequires:  zip
%if %with repolib
BuildRequires:  maven2-plugin-deploy
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
ASM is a code manipulation tool to implement adaptable systems.

%package -n %{shortname}
Summary:        Code manipulation tool to implement adaptable systems
Group:          Development/Libraries/Java
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils

%description -n %{shortname}
ASM is a code manipulation tool to implement adaptable systems.

%package -n %{shortname}-javadoc
Summary:        Javadoc for %{shortname}
Group:          Development/Documentation
Requires:       jpackage-utils

%description -n %{shortname}-javadoc
Javadoc for %{shortname}.

%if %with repolib
%package -n %{shortname}-repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description -n %{shortname}-repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n asm-%{version}
perl -pi -e 's/\r$//g' LICENSE.txt README.txt
%patch0 -p1 -b .sav0

mkdir META-INF
cp -p %{SOURCE9} META-INF/MANIFEST.MF

%build
export CLASSPATH=
export OPT_JAR_LIST=:
%{ant} -Dobjectweb.ant.tasks.path=$(build-classpath objectweb-anttask) jar jdoc

%install
rm -rf %{buildroot}

# jars
mkdir -p %{buildroot}%{_javadir}/%{shortname}
mkdir -p %{buildroot}%{_javadir}/%{name}

for jar in output/dist/lib/*.jar; do
    cp -p ${jar} %{buildroot}%{_javadir}/%{shortname}/`basename ${jar}`
done

touch META-INF/MANIFEST.MF
zip -q -u output/dist/lib/all/asm-all-%{namedversion}.jar META-INF/MANIFEST.MF

cp -p output/dist/lib/all/asm-all-%{namedversion}.jar %{buildroot}%{_javadir}/%{shortname}/
cp -p output/dist/lib/all/asm-debug-all-%{namedversion}.jar %{buildroot}%{_javadir}/%{shortname}/

(cd %{buildroot}%{_javadir}/%{shortname} && for jar in *-%{namedversion}*; do ln -s ${jar} ${jar/-%{namedversion}/}; done)

# Alternative JAR location
for jar in output/dist/lib/*.jar; do
    cp -p ${jar} %{buildroot}%{_javadir}/%{name}/`basename ${jar}`
done

cp -p output/dist/lib/all/asm-all-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/
cp -p output/dist/lib/all/asm-debug-all-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}/

(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{namedversion}*; do ln -s ${jar} ${jar/-%{namedversion}/}; done)

# pom
mkdir -p %{buildroot}%{_datadir}/maven2/poms
cp -p %{SOURCE11} %{buildroot}%{_datadir}/maven2/poms/JPP.%{shortname}-asm.pom
%add_to_maven_depmap org.objectweb.asm asm %{namedversion} JPP/%{shortname} asm
%add_to_maven_depmap asm asm %{namedversion} JPP/%{shortname} asm
cp -p %{SOURCE12} %{buildroot}%{_datadir}/maven2/poms/JPP.%{shortname}-asm-analysis.pom
%add_to_maven_depmap org.objectweb.asm asm-analysis %{namedversion} JPP/%{shortname} asm-analysis
%add_to_maven_depmap asm asm-analysis %{namedversion} JPP/%{shortname} asm-analysis
cp -p %{SOURCE13} %{buildroot}%{_datadir}/maven2/poms/JPP.%{shortname}-asm-commons.pom
%add_to_maven_depmap org.objectweb.asm asm-commons %{namedversion} JPP/%{shortname} asm-commons
%add_to_maven_depmap asm asm-commons %{namedversion} JPP/%{shortname} asm-commons
cp -p %{SOURCE20} %{buildroot}%{_datadir}/maven2/poms/JPP.%{shortname}-asm-debug-all.pom
%add_to_maven_depmap org.objectweb.asm asm-debug-all %{namedversion} JPP/%{shortname} asm-debug-all
%add_to_maven_depmap asm asm-debug-all %{namedversion} JPP/%{shortname} asm-debug-all
cp -p %{SOURCE14} %{buildroot}%{_datadir}/maven2/poms/JPP.%{shortname}-asm-tree.pom
%add_to_maven_depmap org.objectweb.asm asm-tree %{namedversion} JPP/%{shortname} asm-tree
%add_to_maven_depmap asm asm-tree %{namedversion} JPP/%{shortname} asm-tree
cp -p %{SOURCE15} %{buildroot}%{_datadir}/maven2/poms/JPP.%{shortname}-asm-util.pom
%add_to_maven_depmap org.objectweb.asm asm-util %{namedversion} JPP/%{shortname} asm-util
%add_to_maven_depmap asm asm-util %{namedversion} JPP/%{shortname} asm-util
cp -p %{SOURCE16} %{buildroot}%{_datadir}/maven2/poms/JPP.%{shortname}-asm-xml.pom
%add_to_maven_depmap org.objectweb.asm asm-xml %{namedversion} JPP/%{shortname} asm-xml
%add_to_maven_depmap asm asm-xml %{namedversion} JPP/%{shortname} asm-xml
cp -p %{SOURCE17} %{buildroot}%{_datadir}/maven2/poms/JPP.%{shortname}-asm-all.pom
%add_to_maven_depmap org.objectweb.asm asm-all %{namedversion} JPP/%{shortname} asm-all
%add_to_maven_depmap asm asm-all %{namedversion} JPP/%{shortname} asm-all
cp -p %{SOURCE18} %{buildroot}%{_datadir}/maven2/poms/JPP.%{shortname}-asm-parent.pom
%add_to_maven_depmap org.objectweb.asm asm-parent %{namedversion} JPP/%{shortname} asm-parent
%add_to_maven_depmap asm asm-parent %{namedversion} JPP/%{shortname} asm-parent

# javadoc
install -p -d -m 755 %{buildroot}%{_javadocdir}/%{shortname}-%{namedversion}
cp -pr output/dist/doc/javadoc/user/* %{buildroot}%{_javadocdir}/%{shortname}-%{namedversion}
ln -s %{shortname}-%{namedversion} %{buildroot}%{_javadocdir}/%{shortname}

%if %with repolib
%{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{namedversion} -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP.%{shortname}-asm.pom -Dfile=%{buildroot}%{_javadir}/%{shortname}/asm-%{namedversion}.jar -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{namedversion} -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP.%{shortname}-asm-analysis.pom -Dfile=%{buildroot}%{_javadir}/%{shortname}/asm-analysis-%{namedversion}.jar -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{namedversion} -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP.%{shortname}-asm-commons.pom -Dfile=%{buildroot}%{_javadir}/%{shortname}/asm-commons-%{namedversion}.jar -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{namedversion} -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP.%{shortname}-asm-tree.pom -Dfile=%{buildroot}%{_javadir}/%{shortname}/asm-tree-%{namedversion}.jar -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{namedversion} -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP.%{shortname}-asm-util.pom -Dfile=%{buildroot}%{_javadir}/%{shortname}/asm-util-%{namedversion}.jar -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{namedversion} -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP.%{shortname}-asm-xml.pom -Dfile=%{buildroot}%{_javadir}/%{shortname}/asm-xml-%{namedversion}.jar -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{namedversion} -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP.%{shortname}-asm-all.pom -Dfile=%{buildroot}%{_javadir}/%{shortname}/asm-all-%{namedversion}.jar -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{_bindir}/mvn-jpp deploy:deploy-file -Dversion=%{namedversion} -Dfile=%{buildroot}%{_datadir}/maven2/poms/JPP.%{shortname}-asm-parent.pom -DgroupId=org.objectweb.asm -DartifactId=asm-parent -Dpackaging=pom -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

%clean
rm -rf %{buildroot}

%post -n %{shortname}
%update_maven_depmap

%postun -n %{shortname}
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}*/%{name}
%{_javadir}*/%{name}/*jar
%exclude %dir %{_javadocdir}/%{shortname}

%files -n %{shortname}
%defattr(0644,root,root,0755)
%doc LICENSE.txt README.txt
%dir %{_javadir}*/%{shortname}
%exclude %dir %{_javadocdir}/%{shortname}
%{_javadir}*/%{shortname}/asm-%{namedversion}.jar
%{_javadir}*/%{shortname}/asm-all-%{namedversion}.jar
%{_javadir}*/%{shortname}/asm-all.jar
%{_javadir}*/%{shortname}/asm-analysis-%{namedversion}.jar
%{_javadir}*/%{shortname}/asm-analysis.jar
%{_javadir}*/%{shortname}/asm-commons-%{namedversion}.jar
%{_javadir}*/%{shortname}/asm-commons.jar
%{_javadir}*/%{shortname}/asm-debug-all-%{namedversion}.jar
%{_javadir}*/%{shortname}/asm-debug-all.jar
%{_javadir}*/%{shortname}/asm-tree-%{namedversion}.jar
%{_javadir}*/%{shortname}/asm-tree.jar
%{_javadir}*/%{shortname}/asm-util-%{namedversion}.jar
%{_javadir}*/%{shortname}/asm-util.jar
%{_javadir}*/%{shortname}/asm-xml-%{namedversion}.jar
%{_javadir}*/%{shortname}/asm-xml.jar
%{_javadir}*/%{shortname}/asm.jar
%{_datadir}/maven2/poms/JPP.%{shortname}-asm-all.pom
%{_datadir}/maven2/poms/JPP.%{shortname}-asm-analysis.pom
%{_datadir}/maven2/poms/JPP.%{shortname}-asm-commons.pom
%{_datadir}/maven2/poms/JPP.%{shortname}-asm-debug-all.pom
%{_datadir}/maven2/poms/JPP.%{shortname}-asm-parent.pom
%{_datadir}/maven2/poms/JPP.%{shortname}-asm-tree.pom
%{_datadir}/maven2/poms/JPP.%{shortname}-asm-util.pom
%{_datadir}/maven2/poms/JPP.%{shortname}-asm-xml.pom
%{_datadir}/maven2/poms/JPP.%{shortname}-asm.pom
%{_mavendepmapfragdir}/%{name}

%files -n %{shortname}-javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{shortname}-%{namedversion}
%{_javadocdir}/%{shortname}

%if %with repolib
%files -n %{shortname}-repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Tue Apr 23 2013 Vladimir Dosoudil <dosoudil@redhat.com> - 0:3.3.1-6.2.redhat_4
- BZ-901103

* Fri Mar 29 2013 Lin Gao <lgao@redhat.com> - 0:3.3.1-6.1.redhat_3
- Fix nvalid content of Implementation-Version (BZ:928078)

* Thu Jan 17 2013 Fernando Nasser <fnasser@redhat.com> - 0:3.3.1-5.1.redhat_2
- BR apache-commons-parent (needed on RHEL-7)

* Tue Aug 14 2012 Fernando Nasser <fnasser@redhat.com> - 0:3.3.1-5_redhat_2.3
- Rebuild for deploy bug workaround
`
* Tue Aug 14 2012 Fernando Nasser <fnasser@redhat.com> - 0:3.3.1-5_redhat_2.2.3
- Rebuild unsigned

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:3.3.1-5_redhat_1.2.1
- Rebuild using cache signing

* Thu Apr 05 2012 Martha Benitez <mbenitez@redhat.com> - 0:3.3.1-5_redhat_1.2
- Rebuild with a -eap6 suffix to avoid conflict with RHEL-6 base

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:3.3.1-5_redhat_1.1.1
- Rebuild using cache signing

* Tue Feb 14 2012 Fernando Nasser <fnasser@redhat.com> 0:3.3.1-5._redhat_1.1
- Do not require JAXP at run-time (provided)

* Thu Dec 29 2011 Yong Yang <yyang@redhat.com> 0:3.3.1-4.4_redhat_1
- Fix version in repolib, use full name jars

* Thu Dec 29 2011 Yong Yang <yyang@redhat.com> 0:3.3.1-4.3_redhat_1
- Build for Werewolf

* Tue Sep 13 2011 Yong Yang <yyang@redhat.com> 0:3.3.1-4.2
- Fix typo {version} in repolib

* Mon Jun 27 2011 David Walluck <dwalluck@redhat.com> 0:3.3.1-4.1
- fix POM names
- add repolib
- update file list

* Sat Jun 25 2011 David Walluck <dwalluck@redhat.com> 0:3.3.1-4
- keep the asm groupId

* Mon Apr 04 2011 David Walluck <dwalluck@redhat.com> 0:3.3.1-3
- fix file list

* Mon Apr 04 2011 David Walluck <dwalluck@redhat.com> 0:3.3.1-2
- fix maven depmaps
- don't own maven2 poms dir
- use explicit file list
- really install asm-debug-all jar

* Sat Feb 12 2011 David Walluck <dwalluck@redhat.com> 0:3.3.1-1
- 3.3.1
- include asm-debug-all

* Wed Oct 06 2010 Ralph Apel <r.apel@r-apel.de> 0:3.2-2
- Fix groupId in added poms

* Fri Sep 24 2010 Ralph Apel <r.apel@r-apel.de> 0:3.2-1
- 3.2

* Tue Oct 23 2008 David Walluck <dwalluck@redhat.com> 0:3.1-5
- add OSGi manifest (Alexander Kurtakov)

* Mon Oct 20 2008 David Walluck <dwalluck@redhat.com> 0:3.1-4
- remove Class-Path from MANIFEST.MF
- add unversioned javadoc symlink
- remove javadoc scriptlets
- fix directory ownership
- remove build requirement on dos2unix

* Fri Feb 08 2008 Ralph Apel <r.apel@r-apel.de> - 0:3.1-3jpp
- Add poms and depmap frags with groupId of org.objectweb.asm !
- Add asm-all.jar 
- Add -javadoc Requires post and postun
- Restore Vendor, Distribution

* Thu Nov 22 2007 Fernando Nasser <fnasser@redhat.com> - 0:3.1-2jpp
- Fix EOL of txt files
- Add dependency on jaxp 

* Thu Nov 22 2007 Fernando Nasser <fnasser@redhat.com> - 0:3.1-1jpp
- Upgrade to 3.1

* Wed Aug 22 2007 Fernando Nasser <fnasser@redhat.com> - 0:3.0-1jpp
- Upgrade to 3.0
- Rename to include objectweb- prefix as requested by ObjectWeb

* Thu Jan 05 2006 Fernando Nasser <fnasser@redhat.com> - 0:2.1-2jpp
- First JPP 1.7 build

* Thu Oct 06 2005 Ralph Apel <r.apel at r-apel.de> 0:2.1-1jpp
- Upgrade to 2.1

* Fri Mar 11 2005 Sebastiano Vigna <vigna at acm.org> 0:2.0.RC1-1jpp
- First release of the 2.0 line.
